module cartop(
	clk,
	rst,
	echoFL,
	echoL,
	echoR,
	echoFR,
	start,
	stop,
	trigFL,
	trigL,
	trigR,
	trigFR,
	pwA1,
	pwA2,
	pwB1,
	pwB2,
	pwC1,
	pwC2,
	pwD1,
	pwD2,
	direction);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst;
	input echoFL;
	input echoL;
	input echoR;
	input echoFR;
	input start;
	input stop;
	output trigFL;
	output trigL;
	output trigR;
	output trigFR;
	output pwA1;
	output pwA2;
	output pwB1;
	output pwB2;
	output pwC1;
	output pwC2;
	output pwD1;
	output pwD2;
	input [3:0] direction;

	wire clk;
	wire rst;
	wire echoFL;
	wire echoL;
	wire echoR;
	wire echoFR;
	wire start;
	wire stop;
	wire trigFL;
	wire trigL;
	wire trigR;
	wire trigFR;
	wire pwA1;
	wire pwA2;
	wire pwB1;
	wire pwB2;
	wire pwC1;
	wire pwC2;
	wire pwD1;
	wire pwD2;
	wire [3:0] direction;
	wire [20 : 0] carcontrol1_dutyA1;
	wire [20 : 0] carcontrol1_dutyA2;
	wire [20 : 0] carcontrol1_dutyB1;
	wire [20 : 0] carcontrol1_dutyB2;
	wire [20 : 0] carcontrol1_dutyC1;
	wire [20 : 0] carcontrol1_dutyC2;
	wire [20 : 0] carcontrol1_dutyD1;
	wire [20 : 0] carcontrol1_dutyD2;
	wire [13:0] HC_SR04_top3_o_s_mm;
	wire [13:0] HC_SR04_top5_o_s_mm;
	wire [13:0] HC_SR04_top6_o_s_mm;
	wire [13:0] HC_SR04_top4_o_s_mm;
	wire [4:0] avoid7_modeset;

	//----Code starts here: integrated by Robei-----
	
	
	
	
	//---Module instantiation---
	carcontrol carcontrol1(
		.clr(rst),
		.clk(clk),
		.dutyA1(carcontrol1_dutyA1),
		.dutyA2(carcontrol1_dutyA2),
		.dutyB1(carcontrol1_dutyB1),
		.dutyB2(carcontrol1_dutyB2),
		.dutyC1(carcontrol1_dutyC1),
		.dutyC2(carcontrol1_dutyC2),
		.dutyD1(carcontrol1_dutyD1),
		.dutyD2(carcontrol1_dutyD2),
		.modeset(avoid7_modeset));

	HC_SR04_top HC_SR04_top3(
		.sys_clk(clk),
		.sys_rst_n(rst),
		.i_echo(echoFL),
		.o_trig(trigFL),
		.o_s_mm(HC_SR04_top3_o_s_mm));

	HC_SR04_top HC_SR04_top4(
		.sys_clk(clk),
		.sys_rst_n(rst),
		.i_echo(echoR),
		.o_trig(trigR),
		.o_s_mm(HC_SR04_top4_o_s_mm));

	HC_SR04_top HC_SR04_top5(
		.sys_clk(clk),
		.sys_rst_n(rst),
		.i_echo(echoFR),
		.o_trig(trigFR),
		.o_s_mm(HC_SR04_top5_o_s_mm));

	HC_SR04_top HC_SR04_top6(
		.sys_clk(clk),
		.sys_rst_n(rst),
		.i_echo(echoL),
		.o_trig(trigL),
		.o_s_mm(HC_SR04_top6_o_s_mm));

	car car7(
		.dutyA1(carcontrol1_dutyA1),
		.clk(clk),
		.clr(rst),
		.pwA1(pwA1),
		.pwA2(pwA2),
		.pwB1(pwB1),
		.pwB2(pwB2),
		.pwC1(pwC1),
		.pwC2(pwC2),
		.pwD1(pwD1),
		.pwD2(pwD2),
		.dutyA2(carcontrol1_dutyA2),
		.dutyB1(carcontrol1_dutyB1),
		.dutyB2(carcontrol1_dutyB2),
		.dutyC1(carcontrol1_dutyC1),
		.dutyC2(carcontrol1_dutyC2),
		.dutyD1(carcontrol1_dutyD1),
		.dutyD2(carcontrol1_dutyD2));

	avoid avoid7(
		.clr(rst),
		.clk(clk),
		.frontright(HC_SR04_top5_o_s_mm),
		.frontleft(HC_SR04_top3_o_s_mm),
		.left(HC_SR04_top6_o_s_mm),
		.right(HC_SR04_top4_o_s_mm),
		.modeset(avoid7_modeset),
		.stop(stop),
		.start(start),
		.direction(direction));

endmodule    //cartop

