module DHT11(
	sys_clk ,
	sys_rst_n,
	seg_sel,
	seg_led,
	dht11);

	//---Ports declearation: generated by Robei---
	input sys_clk ;
	input sys_rst_n;
	output [5:0] seg_sel;
	output [7:0] seg_led;
	inout dht11;

	wire sys_clk ;
	wire sys_rst_n;
	wire [5:0] seg_sel;
	wire [7:0] seg_led;
	wire dht11;
	wire [31:0] dht11_drive2_data_valid;
	wire [19:0] DHT11_chg4_data_sel;
	wire [7:0] datapaas5_data_T;
	wire [7:0] datapaas5_data_H;
	wire datapaas5_sign;
	wire datapaas5_en;
	wire [5:0] datapaas5_point;

	//----Code starts here: integrated by Robei-----
	
	
	
	
	//---Module instantiation---
	dht11_drive dht11_drive2(
		.sys_clk(sys_clk ),
		.rst_n(sys_rst_n),
		.data_valid(dht11_drive2_data_valid),
		.dht11(dht11));

	datapaas datapaas5(
		.clk(sys_clk ),
		.rst(sys_rst_n),
		.data_sel(DHT11_chg4_data_sel),
		.data_valid(dht11_drive2_data_valid),
		.point(datapaas5_point),
		.en(datapaas5_en),
		.sign(datapaas5_sign),
		.data_T(datapaas5_data_T),
		.data_H(datapaas5_data_H));

	DHT11_chg DHT11_chg4(
		.sys_clk(sys_clk ),
		.sys_rst_n(sys_rst_n),
		.data_T(datapaas5_data_T),
		.data_H(datapaas5_data_H),
		.data_sel(DHT11_chg4_data_sel));

	seg_LED seg_LED4(
		.clk(sys_clk ),
		.rst_n(sys_rst_n),
		.data(DHT11_chg4_data_sel),
		.point(datapaas5_point),
		.en(datapaas5_en),
		.sign(datapaas5_sign),
		.seg_sel(seg_sel),
		.seg_led(seg_led));

endmodule    //DHT11

