module dht11_drive(
	sys_clk,
	rst_n,
	data_valid,
	dht11);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input rst_n;
	output [31:0] data_valid;
	inout dht11;

	wire sys_clk;
	wire rst_n;
	reg [31:0] data_valid;
	wire dht11;

	//----Code starts here: integrated by Robei-----
	localparam	WAIT_1S		= 6'b000001 ,
				START       = 6'b000010 ,
				DELAY_10us  = 6'b000100 ,
				REPLY       = 6'b001000 ,
				DELAY_75us  = 6'b010000 ,
				REV_data	= 6'b100000 ;
	//ʱ
	localparam	T_1S = 999_999	,				//ϵ1sʱλus
				T_BE = 17_999	,				//ʼźʱ䣬λus
				T_GO = 12		;				//ͷʱ䣬λus
	 
	//------------<reg>----------------------------------------------									
	reg	[6:0]	cur_state	;					//̬
	reg	[6:0]	next_state	;					//̬
	reg	[4:0]	cnt			;					//50Ƶ1Mhz(1us)
	reg			dht11_out	;					//˫
	reg			dht11_en	;					//˫ʹܣ10̬
	reg			dht11_d1	;					//źŴ1
	reg			dht11_d2	;					//źŴ2
	reg			clk_us		;					//usʱ
	reg [21:0]	cnt_us		;					//us,ɱʾ4.2s
	reg [5:0]	bit_cnt		;					//ݼԱʾ64λ
	reg [39:0]	data_temp	;					//У40λ
	 
	//------------<wire>----------------------------------------------		
	wire		dht11_in	;					//˫
	wire		dht11_rise	;					//
	wire		dht11_fall	;					//½
	 
	//==================================================================
	//===========================<main  code>===========================
	//==================================================================
	 
	//-----------------------------------------------------------------------
	//--˫˿ʹ÷ʽ
	//-----------------------------------------------------------------------
	assign	dht11_in = dht11;							//̬Ļϵݸdht11_in
	assign	dht11 =  dht11_en ? dht11_out : 1'bz;		//ʹ10̬
	//-----------------------------------------------------------------------
	//--usʱɣΪʱusΪλһ1usʱӻȽϷ
	//-----------------------------------------------------------------------
	//50Ƶ
	always @(posedge sys_clk or negedge rst_n)begin
		if(!rst_n)
			cnt <= 5'd0;
		else if(cnt == 5'd24)				//ÿ25ʱ500ns
			cnt <= 5'd0;
		else
			cnt <= cnt + 1'd1;
	end
	//1usʱ
	always @(posedge sys_clk or negedge rst_n)begin
		if(!rst_n)
			clk_us <= 1'b0;
		else  if(cnt == 5'd24)				//ÿ500ns
			clk_us <= ~clk_us;				//ʱӷת
		else
			clk_us <= clk_us;
	end
	//-----------------------------------------------------------------------
	//--½ؼ·
	//-----------------------------------------------------------------------
	//ϵغ½
	assign	dht11_rise = ~dht11_d2 && dht11_d1;			//
	assign	dht11_fall = ~dht11_d1 && dht11_d2;			//½
	//dht11ģغ½
	always @(posedge clk_us or negedge rst_n)begin
		if(!rst_n)begin
			dht11_d1 <= 1'b0;				//λʼΪ0
			dht11_d2 <= 1'b0;				//λʼΪ0
		end
		else begin
			dht11_d1 <= dht11;				//1
			dht11_d2 <= dht11_d1;			//2
		end
	end
	//-----------------------------------------------------------------------
	//--ʽ״̬
	//-----------------------------------------------------------------------
	//״̬һΣͬʱ״̬ת
	always @(posedge clk_us or negedge rst_n)begin
		if(!rst_n)		
			cur_state <= WAIT_1S;			
		else
			cur_state <= next_state;
	end
	//״̬ڶΣ߼ж״̬ת״̬תƹԼ
	always @(*)begin
		next_state = WAIT_1S;
		case(cur_state)
			WAIT_1S		:begin
				if(cnt_us == T_1S)				//ϵʱʱ	
					next_state = START;			//תSTART
				else	
					next_state = WAIT_1S;		//״̬
			end	
			START       :begin	
				if(cnt_us == T_BE)				//ߵʱ
					next_state = DELAY_10us;	//תDELAY_10us
				else
					next_state = START;			//״̬
			end
			DELAY_10us  :begin					
				if(cnt_us == T_GO)				//ͷʱ
					next_state = REPLY;			//תREPLY
				else
					next_state = DELAY_10us;	//״̬
			end
			REPLY       :begin
				if(cnt_us <= 'd500)begin		//500us
					if(dht11_rise && cnt_us >= 'd70 
					  && cnt_us <= 'd100)				//Ӧҵ͵ƽʱ70~100us
						next_state = DELAY_75us;		//תDELAY_75us
					else
						next_state = REPLY;				//״̬
				end	
				else	
					next_state = START;					//500usûӦתSTART
			end	
			DELAY_75us  :begin	
				if(dht11_fall && cnt_us >= 'd70)		//Ӧҵ͵ƽʱ70us
					next_state = REV_data;				//תREV_data
				else 	
					next_state = DELAY_75us;			//״̬
			end	
			REV_data	:begin	
				if(dht11_rise && bit_cnt == 'd40)		//40ݺһʱΪ
														//׽ҽݸΪ40				
					next_state = START;					//״̬תSTART¿ʼһֲɼ
				else 	
					next_state = REV_data;				//״̬
			end	
			default:next_state = START;					//Ĭ״̬ΪSTART
		endcase
	end	
	 
	//״̬Σʱ߼
	always @(posedge clk_us or negedge rst_n)begin
		if(!rst_n)begin										//λ״̬						
			dht11_en <= 1'b0;
			dht11_out <= 1'b0;
			cnt_us <= 22'd0;
			bit_cnt <=  6'd0;
			data_temp <= 40'd20; 	
		end
		else 	
			case(cur_state)
				WAIT_1S		:begin
					dht11_en <= 1'b0;						//ͷߣⲿ
					if(cnt_us == T_1S)						
						cnt_us <= 22'd0;					//ʱ
					else
						cnt_us <= cnt_us + 1'd1;			//ʱʱ
				end
				START		:begin
					dht11_en <= 1'b1;						//ռ
					dht11_out <= 1'b0;						//͵ƽ
					if(cnt_us == T_BE)		
						cnt_us <= 22'd0;					//ʱ
					else		
						cnt_us <= cnt_us + 1'd1;			//ʱʱ
				end		
				DELAY_10us	:begin		
					dht11_en <= 1'b0;						//ͷߣⲿ
					if(cnt_us == T_GO)
						cnt_us <= 22'd0;					//ʱ
					else                                    
						cnt_us <= cnt_us + 1'd1;            //ʱʱ
				end	
				REPLY		:begin
					dht11_en <= 1'b0;						//ͷߣⲿ
					if(cnt_us <= 'd500)begin				//ʱ500us
						if(dht11_rise && cnt_us >= 'd70 
						  && cnt_us <= 'd100)				//Ӧҵ͵ƽʱ70~100us
							cnt_us <= 22'd0;				//ʱ
						else
							cnt_us <= cnt_us + 1'd1;		//ʱʱ
					end
					else 
						cnt_us <= 22'd0;					//500usûӦ 
				end	
				DELAY_75us  :begin
					dht11_en <= 1'b0;						//ͷߣⲿ
					if(dht11_fall && cnt_us >= 'd70)		//Ӧҵ͵ƽʱ70us
						cnt_us <= 22'd0;					//ʱ
					else 	
						cnt_us <= cnt_us + 1'd1;			//ʱʱ
				end
				REV_data	:begin
					dht11_en <= 1'b0;						//ͷߣⲿߣȡ״̬
					if(dht11_rise && bit_cnt == 'd40)begin	//ݽ
						bit_cnt <=  6'd0; 					//ݽռ
						cnt_us <= 22'd0;					//ռʱ
					end
					else if(dht11_fall)begin				//⵽͵ƽ˵յһ
						bit_cnt <= bit_cnt + 1'd1;			//ݽռ+1
						cnt_us <= 22'd0;					//ʱ¼
						if(cnt_us <= 'd100)					
							data_temp[39-bit_cnt] <= 1'b0;	//ܹеʱ100us,˵յ"0"
						else 
							data_temp[39-bit_cnt] <= 1'b1;	//ܹеʱ100us,˵յ"1"
					end
					else begin								//ûн꣬1ݵĽս
						bit_cnt <= bit_cnt;				
						data_temp <= data_temp;
						cnt_us <= cnt_us + 1'd1;			//ʱʱ
					end
				end
				default:;		
			endcase
	end
	 
	//УȡǷУ
	always @(posedge clk_us or negedge rst_n)begin
		if(!rst_n)
			data_valid <= 32'd20000;
		else if((data_temp[7:0] == data_temp[39:32] + data_temp[31:24] +
		data_temp[23:16] + data_temp[15:8]))
			data_valid <= data_temp[39:8]; 		//ϹЧݸֵ
		else
			data_valid <= data_valid;			//ϹζȡݣԱϴε״̬
	end
	
	
	
endmodule    //dht11_drive

