module seg_LED(
	clk,
	rst_n,
	data,
	point,
	en,
	sign,
	seg_sel,
	seg_led);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input [19:0] data;
	input [5:0] point;
	input en;
	input sign;
	output [5:0] seg_sel;
	output [7:0] seg_led;

	wire clk;
	wire rst_n;
	wire [19:0] data;
	wire [5:0] point;
	wire en;
	wire sign;
	reg [5:0] seg_sel;
	reg [7:0] seg_led;

	//----Code starts here: integrated by Robei-----
	 localparam CLK_DIVIDE = 4'd10 ; // ʱӷƵϵ
	 localparam MAX_NUM = 13'd5000 ; // ʱ(5MHz) 1ms ļֵ
	 
	 //reg define
	 reg [ 3:0] clk_cnt ; // ʱӷƵ
	 reg dri_clk ; // ܵʱ,5MHz
	 reg [23:0] num ; // 24 λ bcd Ĵ
	 reg [12:0] cnt0 ; // ʱӼ
	 reg flag ; // ־źţ־ cnt0  1ms
	 reg [2:0] cnt_sel ; // λѡ
	 reg [3:0] num_disp ; // ǰʾ
	 reg dot_disp ; // ǰʾС
	
	 //wire define
	 wire [3:0] data0 ; // λ
	 wire [3:0] data1 ; // ʮλ
	 wire [3:0] data2 ; // λ
	 wire [3:0] data3 ; // ǧλ
	 wire [3:0] data4 ; // λ
	 wire [3:0] data5 ; // ʮλ
	 
	 //ȡʾֵӦʮĸλ
	 assign data0 = data % 4'd10; // λ
	 assign data1 = data / 4'd10 % 4'd10 ; // ʮλ
	 assign data2 = data / 7'd100 % 4'd10 ; // λ
	 assign data3 = data / 10'd1000 % 4'd10 ; // ǧλ
	 assign data4 = data / 14'd10000 % 4'd10; // λ
	 assign data5 = data / 17'd100000; // ʮλ
	 
	 //ϵͳʱ 10 ƵõƵΪ 5MHz ʱ dri_clk
	 always @(posedge clk or negedge rst_n) begin
	 if(!rst_n) begin
	 clk_cnt <= 4'd0;
	 dri_clk <= 1'b1;
	 end
	 else if(clk_cnt == CLK_DIVIDE/2 - 1'd1) begin
	 clk_cnt <= 4'd0;
	 dri_clk <= ~dri_clk;
	 end
	 else begin
	 clk_cnt <= clk_cnt + 1'b1;
	 dri_clk <= dri_clk;
	 end
	 end
	
	 // 20 λ 2 תΪ 8421bcd (ʹ 4 λʾ 1 λʮ
	 always @ (posedge dri_clk or negedge rst_n) begin
	 if (!rst_n)
	 num <= 24'b0;
	 else begin
	 if (data5 || point[5]) begin //ʾΪ 6 λʮ
	 num[23:20] <= data5; //θ 6 λֵܸ
	 num[19:16] <= data4;
	 num[15:12] <= data3;
	 num[11:8] <= data2;
	 num[ 7:4] <= data1;
	 num[ 3:0] <= data0;
	 end
	 else begin 
	 if (data4 || point[4]) begin //ʾΪ 5 λʮ 5 λֵܸ
	 num[19:0] <= {data4,data3,data2,data1,data0};
	 if(sign) 
	 num[23:20] <= 4'd11; //Ҫʾţλ 6 λΪλ
	 else
	 num[23:20] <= 4'd10; //Ҫʾʱ 6 λʾκַ
	 end
	 else begin //ʾΪ 4 λʮ 4 λֵܸ
	 if (data3 || point[3]) begin
	 num[15: 0] <= {data3,data2,data1,data0};
	 num[23:20] <= 4'd10; // 6 λʾκַ
	 if(sign) //Ҫʾţλ 5 λΪλ
	 num[19:16] <= 4'd11;
	 else //Ҫʾʱ 5 λʾκַ
	 num[19:16] <= 4'd10;
	 end
	 else begin //ʾΪ 3 λʮ 3 λֵܸ
	 if (data2 || point[2]) begin
	 num[11: 0] <= {data2,data1,data0};
	 // 65 λʾκַ
	 num[23:16] <= {2{4'd10}};
	 if(sign) //Ҫʾţλ 4 λΪλ
	 num[15:12] <= 4'd11;
	 else //Ҫʾʱ 4 λʾκַ
	 num[15:12] <= 4'd10;
	 end
	 else begin //ʾΪ 2 λʮ 2 λֵܸ
	 if (data1 || point[1]) begin
	 num[ 7: 0] <= {data1,data0};
	 // 654 λʾκַ
	 num[23:12] <= {3{4'd10}};
	 if(sign) //Ҫʾţλ 3 λΪλ
	 num[11:8] <= 4'd11;
	 else //Ҫʾʱ 3 λʾκַ
	 num[11:8] <= 4'd10;
	 end
	 else begin //ʾΪ 1 λʮλֵܸ
	 num[3:0] <= data0;
	 // 65 λʾκַ
	 num[23:8] <= {4{4'd10}};
	 if(sign) //Ҫʾţλ 2 λΪλ
	 num[7:4] <= 4'd11;
	 else //Ҫʾʱ 2 λʾκַ
	 num[7:4] <= 4'd10;
	 end
	 end
	 end
	 end
	 end
	 end
	 end
	
	 //ÿʱӼʱ 1msһʱڵź
	 always @ (posedge dri_clk or negedge rst_n) begin
	 if (rst_n == 1'b0) begin
	 cnt0 <= 13'b0;
	 flag <= 1'b0;
	 end
	 else if (cnt0 < MAX_NUM - 1'b1) begin
	 cnt0 <= cnt0 + 1'b1;
	 flag <= 1'b0;
	 end
	 else begin
	 cnt0 <= 13'b0;
	 flag <= 1'b1;
	 end
	 end
	
	 //cnt_sel  0  5ѡǰʾ״̬
	 always @ (posedge dri_clk or negedge rst_n) begin
	 if (rst_n == 1'b0)
	 cnt_sel <= 3'b0;
	 else if(flag) begin
	 if(cnt_sel < 3'd5)
	 cnt_sel <= cnt_sel + 1'b1;
	 else
	 cnt_sel <= 3'b0;
	 end
	
	 else
	 cnt_sel <= cnt_sel;
	 end
	
	 //λѡźţʹ 6 λʾ
	 always @ (posedge dri_clk or negedge rst_n) begin
	 if(!rst_n) begin
	 seg_sel <= 6'b111111; //λѡźŵ͵ƽЧ
	 num_disp <= 4'b0; 
	 dot_disp <= 1'b1; //ܣ͵ƽͨ
	 end
	 else begin
	 if(en) begin
	 case (cnt_sel)
	 3'd0 :begin
	 seg_sel <= 6'b111110; //ʾλ
	 num_disp <= num[3:0] ; //ʾ
	 dot_disp <= ~point[0]; //ʾС
	 end
	 3'd1 :begin
	 seg_sel <= 6'b111101; //ʾܵ 1 λ
	 num_disp <= num[7:4] ;
	 dot_disp <= ~point[1];
	 end
	 3'd2 :begin
	 seg_sel <= 6'b111011; //ʾܵ 2 λ
	 num_disp <= num[11:8];
	 dot_disp <= ~point[2];
	 end
	 3'd3 :begin
	 seg_sel <= 6'b110111; //ʾܵ 3 λ
	 num_disp <= num[15:12];
	 dot_disp <= ~point[3];
	 end
	 3'd4 :begin
	 seg_sel <= 6'b101111; //ʾܵ 4 λ
	 num_disp <= num[19:16];
	 dot_disp <= ~point[4];
	 end
	 3'd5 :begin
	 seg_sel <= 6'b011111; //ʾλ
	
	
	
	 num_disp <= num[23:20];
	 dot_disp <= ~point[5];
	 end
	 default :begin
	 seg_sel <= 6'b111111;
	 num_disp <= 4'b0;
	 dot_disp <= 1'b1;
	 end
	 endcase
	 end
	 else begin
	 seg_sel <= 6'b111111; //ʹźΪ 0 ʱܾʾ
	 num_disp <= 4'b0;
	 dot_disp <= 1'b1;
	 end
	 end
	 end
	
	 //ܶѡźţʾַ
	 always @ (posedge dri_clk or negedge rst_n) begin
	 if (!rst_n)
	 seg_led <= 8'hc0;
	 else begin
	 case (num_disp)
	 4'd0 : seg_led <= {dot_disp,7'b1000000}; //ʾ 0
	 4'd1 : seg_led <= {dot_disp,7'b1111001}; //ʾ 1
	 4'd2 : seg_led <= {dot_disp,7'b0100100}; //ʾ 2
	 4'd3 : seg_led <= {dot_disp,7'b0110000}; //ʾ 3
	 4'd4 : seg_led <= {dot_disp,7'b0011001}; //ʾ 4
	 4'd5 : seg_led <= {dot_disp,7'b0010010}; //ʾ 5
	 4'd6 : seg_led <= {dot_disp,7'b0000010}; //ʾ 6
	 4'd7 : seg_led <= {dot_disp,7'b1111000}; //ʾ 7
	 4'd8 : seg_led <= {dot_disp,7'b0000000}; //ʾ 8
	 4'd9 : seg_led <= {dot_disp,7'b0010000}; //ʾ 9
	 4'd10: seg_led <= 8'b11111111; //ʾκַ
	 4'd11: seg_led <= 8'b10111111; //ʾ(-)
	 default:
	 seg_led <= {dot_disp,7'b1000000};
	 endcase
	 end
	 end
	
	
	
endmodule    //seg_LED

