module top(
	sys_clk,
	sys_rst_n,
	cam_pclk,
	cam_vsync,
	cam_href,
	cam_data,
	echoFL,
	echoL,
	echoR,
	echoFR,
	v1,
	v2,
	v3,
	v4,
	v5,
	light_th,
	cam_rst_n,
	cam_pwdn,
	cam_scl,
	ddr3_addr,
	ddr3_ba,
	ddr3_ras_n,
	ddr3_cas_n,
	ddr3_we_n,
	ddr3_reset_n,
	ddr3_ck_p,
	ddr3_ck_n,
	ddr3_cke,
	ddr3_cs_n,
	ddr3_dm,
	ddr3_odt,
	lcd_hs,
	lcd_vs,
	lcd_de,
	lcd_rst,
	lcd_pclk,
	seg_sel,
	seg_led,
	pw1,
	pw2,
	pw3,
	pw4,
	pw5,
	pw6,
	trigFL,
	trigL,
	trigR,
	trigFR,
	pwA1,
	pwA2,
	pwB1,
	pwB2,
	pwC1,
	pwC2,
	pwD1,
	pwD2,
	res_out,
	cam_sda,
	ddr3_dq,
	ddr3_dqs_n,
	ddr3_dqs_p,
	lcd_rgb,
	dht11,
	lcd_bl);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input cam_pclk;
	input cam_vsync;
	input cam_href;
	input [7:0] cam_data;
	input echoFL;
	input echoL;
	input echoR;
	input echoFR;
	input v1;
	input v2;
	input v3;
	input v4;
	input v5;
	input light_th;
	output cam_rst_n;
	output cam_pwdn;
	output cam_scl;
	output [13:0] ddr3_addr;
	output [2:0] ddr3_ba;
	output ddr3_ras_n;
	output ddr3_cas_n;
	output ddr3_we_n;
	output ddr3_reset_n;
	output ddr3_ck_p;
	output ddr3_ck_n;
	output ddr3_cke;
	output ddr3_cs_n;
	output [1:0] ddr3_dm;
	output ddr3_odt;
	output lcd_hs;
	output lcd_vs;
	output lcd_de;
	output lcd_rst;
	output lcd_pclk;
	output [5:0] seg_sel;
	output [7:0] seg_led;
	output pw1;
	output pw2;
	output pw3;
	output pw4;
	output pw5;
	output pw6;
	output trigFL;
	output trigL;
	output trigR;
	output trigFR;
	output pwA1;
	output pwA2;
	output pwB1;
	output pwB2;
	output pwC1;
	output pwC2;
	output pwD1;
	output pwD2;
	output res_out;
	inout cam_sda;
	inout [15:0] ddr3_dq;
	inout [1:0] ddr3_dqs_n;
	inout [1:0] ddr3_dqs_p;
	inout [23:0] lcd_rgb;
	inout dht11;
	output lcd_bl;

	wire sys_clk;
	wire sys_rst_n;
	wire cam_pclk;
	wire cam_vsync;
	wire cam_href;
	wire [7:0] cam_data;
	wire echoFL;
	wire echoL;
	wire echoR;
	wire echoFR;
	wire v1;
	wire v2;
	wire v3;
	wire v4;
	wire v5;
	wire light_th;
	wire cam_rst_n;
	wire cam_pwdn;
	wire cam_scl;
	wire [13:0] ddr3_addr;
	wire [2:0] ddr3_ba;
	wire ddr3_ras_n;
	wire ddr3_cas_n;
	wire ddr3_we_n;
	wire ddr3_reset_n;
	wire ddr3_ck_p;
	wire ddr3_ck_n;
	wire ddr3_cke;
	wire ddr3_cs_n;
	wire [1:0] ddr3_dm;
	wire ddr3_odt;
	wire lcd_hs;
	wire lcd_vs;
	wire lcd_de;
	wire lcd_rst;
	wire lcd_pclk;
	wire [5:0] seg_sel;
	wire [7:0] seg_led;
	wire pw1;
	wire pw2;
	wire pw3;
	wire pw4;
	wire pw5;
	wire pw6;
	wire trigFL;
	wire trigL;
	wire trigR;
	wire trigFR;
	wire pwA1;
	wire pwA2;
	wire pwB1;
	wire pwB2;
	wire pwC1;
	wire pwC2;
	wire pwD1;
	wire pwD2;
	wire res_out;
	wire cam_sda;
	wire [15:0] ddr3_dq;
	wire [1:0] ddr3_dqs_n;
	wire [1:0] ddr3_dqs_p;
	wire [23:0] lcd_rgb;
	wire dht11;
	wire lcd_bl;
	wire change64_rst_n;
	wire [3:0] digital_filter5_digital_out;
	wire [3:0] top_digital_recognition3_digital_out;
	wire [3:0] connect6_direction;
	wire [4:0] connect6_actionchoose;

	//----Code starts here: integrated by Robei-----
	   reg  [27:0] count;
	   reg       rst;
	always@(posedge sys_clk or negedge sys_rst_n)begin
	    if(!sys_rst_n)begin
	        count<=0;
	        rst<=0;
	    end
	    else if(count<28'd50000000)begin
	        count<=count+1;
	        rst<=0;
	    end
	    else if(count==28'd50000000)begin
	        count<=count;
	        rst<=1;
	    end
	end
	
	
	
	//---Module instantiation---
	armtop armtop1(
		.clr(change64_rst_n),
		.clk(sys_clk),
		.actionchoose(connect6_actionchoose),
		.pw1(pw1),
		.pw2(pw2),
		.pw3(pw3),
		.pw4(pw4),
		.pw5(pw5),
		.pw6(pw6));

	cartop cartop2(
		.clk(sys_clk),
		.rst(change64_rst_n),
		.echoFL(echoFL),
		.echoL(echoL),
		.echoR(echoR),
		.echoFR(echoFR),
		.trigFL(trigFL),
		.trigL(trigL),
		.trigR(trigR),
		.trigFR(trigFR),
		.pwA1(pwA1),
		.pwA2(pwA2),
		.pwB1(pwB1),
		.pwB2(pwB2),
		.pwC1(pwC1),
		.pwC2(pwC2),
		.pwD1(pwD1),
		.pwD2(pwD2),
		.direction(connect6_direction));

	top_digital_recognition top_digital_recognition3(
		.sys_clk(sys_clk),
		.sys_rst_n(change64_rst_n),
		.cam_rst_n(cam_rst_n),
		.cam_pwdn(cam_pwdn),
		.cam_scl(cam_scl),
		.ddr3_addr(ddr3_addr),
		.ddr3_ras_n(ddr3_ras_n),
		.ddr3_cas_n(ddr3_cas_n),
		.ddr3_we_n(ddr3_we_n),
		.ddr3_reset_n(ddr3_reset_n),
		.ddr3_ck_p(ddr3_ck_p),
		.ddr3_ck_n(ddr3_ck_n),
		.ddr3_cke(ddr3_cke),
		.ddr3_cs_n(ddr3_cs_n),
		.ddr3_dm(ddr3_dm),
		.ddr3_odt(ddr3_odt),
		.lcd_hs(lcd_hs),
		.lcd_vs(lcd_vs),
		.lcd_de(lcd_de),
		.lcd_bl(lcd_bl),
		.lcd_rst(lcd_rst),
		.lcd_pclk(lcd_pclk),
		.digital_out(top_digital_recognition3_digital_out),
		.cam_sda(cam_sda),
		.ddr3_dq(ddr3_dq),
		.ddr3_dqs_n(ddr3_dqs_n),
		.ddr3_dqs_p(ddr3_dqs_p),
		.lcd_rgb(lcd_rgb));

	change6 change64(
		.rst(rst),
		.sys_rst_n(sys_rst_n),
		.rst_n(change64_rst_n));

	digital_filter digital_filter5(
		.clk(sys_clk),
		.rst(change64_rst_n),
		.digital(top_digital_recognition3_digital_out),
		.digital_out(digital_filter5_digital_out));

	connect connect6(
		.clk(sys_clk),
		.rst(change64_rst_n),
		.digital_out(digital_filter5_digital_out),
		.v1(v1),
		.v2(v2),
		.direction(connect6_direction),
		.actionchoose(connect6_actionchoose));

	DHT11 DHT117(
		.sys_clk (sys_clk),
		.sys_rst_n(change64_rst_n),
		.seg_sel(seg_sel),
		.seg_led(seg_led),
		.dht11(dht11),
		.v3(v3),
		.v4(v4));

	Light_threshold Light_threshold8(
		.sys_clk(sys_clk),
		.sys_rst_n(change64_rst_n),
		.light_th(light_th),
		.res_out(res_out),
		.v5(v5));

endmodule    //top

