module top_digital_recognition(
	sys_clk,
	sys_rst_n,
	cam_pclk,
	cam_vsync,
	cam_href,
	cam_data,
	cam_rst_n,
	cam_pwdn,
	cam_scl,
	ddr3_addr,
	ddr3_ba,
	ddr3_ras_n,
	ddr3_cas_n,
	ddr3_we_n,
	ddr3_reset_n,
	ddr3_ck_p,
	ddr3_ck_n,
	ddr3_cke,
	ddr3_cs_n,
	ddr3_dm,
	ddr3_odt,
	lcd_hs,
	lcd_vs,
	lcd_de,
	lcd_bl,
	lcd_rst,
	lcd_pclk,
	digital_out,
	seg_sel,
	seg_led,
	cam_sda,
	ddr3_dq,
	ddr3_dqs_n,
	ddr3_dqs_p,
	lcd_rgb);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input cam_pclk;
	input cam_vsync;
	input cam_href;
	input [7:0] cam_data;
	output cam_rst_n;
	output cam_pwdn;
	output cam_scl;
	output [13:0] ddr3_addr;
	output [2:0] ddr3_ba;
	output ddr3_ras_n;
	output ddr3_cas_n;
	output ddr3_we_n;
	output ddr3_reset_n;
	output ddr3_ck_p;
	output ddr3_ck_n;
	output ddr3_cke;
	output ddr3_cs_n;
	output [1:0] ddr3_dm;
	output ddr3_odt;
	output lcd_hs;
	output lcd_vs;
	output lcd_de;
	output lcd_bl;
	output lcd_rst;
	output lcd_pclk;
	output [3:0] digital_out;
	output [5:0] seg_sel;
	output [7:0] seg_led;
	inout cam_sda;
	inout [15:0] ddr3_dq;
	inout [1:0] ddr3_dqs_n;
	inout [1:0] ddr3_dqs_p;
	inout [23:0] lcd_rgb;

	wire sys_clk;
	wire sys_rst_n;
	wire cam_pclk;
	wire cam_vsync;
	wire cam_href;
	wire [7:0] cam_data;
	wire cam_rst_n;
	wire cam_pwdn;
	wire cam_scl;
	wire [13:0] ddr3_addr;
	wire [2:0] ddr3_ba;
	wire ddr3_ras_n;
	wire ddr3_cas_n;
	wire ddr3_we_n;
	wire ddr3_reset_n;
	wire ddr3_ck_p;
	wire ddr3_ck_n;
	wire ddr3_cke;
	wire ddr3_cs_n;
	wire [1:0] ddr3_dm;
	wire ddr3_odt;
	wire lcd_hs;
	wire lcd_vs;
	wire lcd_de;
	wire lcd_bl;
	wire lcd_rst;
	wire lcd_pclk;
	wire [3:0] digital_out;
	wire [5:0] seg_sel;
	wire [7:0] seg_led;
	wire cam_sda;
	wire [15:0] ddr3_dq;
	wire [1:0] ddr3_dqs_n;
	wire [1:0] ddr3_dqs_p;
	wire [23:0] lcd_rgb;

	//----Code starts here: integrated by Robei-----
	//wire define                          
	wire         clk_50m                   ;  //50mhzʱ,ṩlcdʱ
	wire         locked                    ;  //ʱź
	wire         rst_n                     ;  //ȫָλ 								    
	wire         i2c_exec                  ;  //I2Cִź
	wire  [23:0] i2c_data                  ;  //I2CҪõĵַ(8λַ,8λ)          
	wire         cam_init_done             ;  //ͷʼ
	wire         i2c_done                  ;  //I2CĴź
	wire         i2c_dri_clk               ;  //I2Cʱ								    
	wire         wr_en                     ;  //DDR3ģдʹ
	wire  [15:0] wr_data                   ;  //DDR3ģд
	wire         rdata_req                 ;  //DDR3ģʹ
	wire  [15:0] rd_data                   ;  //DDR3ģ
	wire         cmos_frame_valid          ;  //Чʹź
	wire         init_calib_complete       ;  //DDR3ʼinit_calib_complete
	wire         sys_init_done             ;  //ϵͳʼ(DDRʼ+ͷʼ)
	wire         clk_200m                  ;  //ddr3οʱ
	wire         cmos_frame_vsync          ;  //֡Чͬź
	
	wire         cmos_frame_href           ;  //֡Чͬź 
	wire  [27:0] app_addr_rd_min           ;  //DDR3ʼַ
	wire  [27:0] app_addr_rd_max           ;  //DDR3Ľַ
	wire  [7:0]  rd_bust_len               ;  //DDR3жʱͻ
	wire  [27:0] app_addr_wr_min           ;  //дDDR3ʼַ
	wire  [27:0] app_addr_wr_max           ;  //дDDR3Ľַ
	wire  [7:0]  wr_bust_len               ;  //DDR3дʱͻ 
	wire         lcd_clk                   ;  //ƵLCD ʱ
	wire  [12:0] h_disp                    ;  //LCDˮƽֱ
	wire  [12:0] v_disp                    ;  //LCDֱֱ     
	wire  [10:0] h_pixel                   ;  //ddr3ˮƽֱ        
	wire  [10:0] v_pixel                   ;  //ddr3ֱֱ 
	wire  [15:0] lcd_id                    ;  //LCDID
	wire  [27:0] ddr3_addr_max             ;  //DDR3дַ 
	wire         i2c_rh_wl                 ;  //I2Cдź             
	wire  [7:0]  i2c_data_r                ;  //I2C 
	wire  [12:0] total_h_pixel             ;  //ˮƽشС 
	wire  [12:0] total_v_pixel             ;  //ֱشС
	wire  [15:0] post_rgb                  ;  //ͼ
	wire         post_frame_vsync          ;  //ĳź
	wire         post_frame_de             ;  //Чʹ 
	wire  [10:0] pixel_xpos                ;  //ص
	wire  [10:0] pixel_ypos                ;  //ص  
	wire  [23:0] digit                     ;  //ص 
	wire   [15:0]         color_rgb       ;
	
	wire                  hs_t            ;
	wire                  vs_t            ;
	wire                  de_t            ;    
	 assign digital_out=digit;
	
	assign  rst_n = sys_rst_n & locked;
	assign  sys_init_done = init_calib_complete;
endmodule    //top_digital_recognition

