module ddr3_fifo_ctrl(
	rst_n,
	wr_clk,
	rd_clk,
	clk_100,
	datain_valid,
	datain,
	rfifo_din,
	rdata_req,
	rfifo_wren,
	wfifo_rden,
	rd_load,
	wr_load,
	wfifo_dout,
	wfifo_rcount,
	rfifo_wcount,
	pic_data);

	//---Ports declearation: generated by Robei---
	input rst_n;
	input wr_clk;
	input rd_clk;
	input clk_100;
	input datain_valid;
	input [15:0] datain;
	input [127:0] rfifo_din;
	input rdata_req;
	input rfifo_wren;
	input wfifo_rden;
	input rd_load;
	input wr_load;
	output [127:0] wfifo_dout;
	output [10:0] wfifo_rcount;
	output [10:0] rfifo_wcount;
	output [15:0] pic_data;

	wire rst_n;
	wire wr_clk;
	wire rd_clk;
	wire clk_100;
	wire datain_valid;
	wire [15:0] datain;
	wire [127:0] rfifo_din;
	wire rdata_req;
	wire rfifo_wren;
	wire wfifo_rden;
	wire rd_load;
	wire wr_load;
	wire [127:0] wfifo_dout;
	wire [10:0] wfifo_rcount;
	wire [10:0] rfifo_wcount;
	reg [15:0] pic_data;
	wire datapass3_pass1;
	wire datapass3_pass2;

	//----Code starts here: integrated by Robei-----
	//reg define
	reg  [127:0] datain_t          ;  //16bitԴλƴӵõ
	reg  [7:0]   cam_data_d0       ; 
	reg  [4:0]   i_d0              ;
	reg  [15:0]  rd_load_d         ;  //Դźλƴӵõ           
	reg  [6:0]   byte_cnt          ;  //дλ
	reg  [127:0] data              ;  //rfifoݴĵõ
	//reg  [15:0]  pic_data          ;  Ч 
	reg  [4:0]   i                 ;  //λ
	reg  [15:0]  wr_load_d         ;  //Դźλƴӵõ 
	reg  [3:0]   cmos_ps_cnt       ;  //ȴ֡ȶ
	reg          cam_href_d0       ;
	reg          cam_href_d1       ;
	reg          wr_load_d0        ;
	reg          rd_load_d0        ;
	reg          rdfifo_rst_h      ;  //rfifoλźţЧ
	reg          wr_load_d1        ;
	reg          wfifo_rst_h       ;  //wfifoλźţЧ
	reg          wfifo_wren        ;  //wfifoдʹź
	
	//wire define 
	wire [127:0] rfifo_dout        ;  //rfifo    
	wire [127:0] wfifo_din         ;  //wfifoд
	wire [15:0]  dataout[0:15]     ;  //ݵĶά
	wire         rfifo_rden        ;  //rfifoĶʹ
	
	
	//rfifoݴ浽ά
	assign dataout[0] = data[127:112];
	assign dataout[1] = data[111:96];
	assign dataout[2] = data[95:80];
	assign dataout[3] = data[79:64];
	assign dataout[4] = data[63:48];
	assign dataout[5] = data[47:32];
	assign dataout[6] = data[31:16];
	assign dataout[7] = data[15:0];
	
	assign wfifo_din = datain_t ;
	
	//λĴʱrfifoһ
	assign rfifo_rden = (rdata_req && (i==7)) ? 1'b1  :  1'b0; 
	
	//16λת128λRGB565        
	always @(posedge wr_clk or negedge rst_n) begin
	    if(!rst_n) begin
	        datain_t <= 0;
	        byte_cnt <= 0;
	    end
	    else if(datain_valid) begin
	        if(byte_cnt == 7)begin
	            byte_cnt <= 0;
	            datain_t <= {datain_t[112:0],datain};
	        end
	        else begin
	            byte_cnt <= byte_cnt + 1;
	            datain_t <= {datain_t[112:0],datain};
	        end
	    end
	    else begin
	        byte_cnt <= byte_cnt;
	        datain_t <= datain_t;
	    end    
	end 
	
	//wfifoдʹܲ
	always @(posedge wr_clk or negedge rst_n) begin
	    if(!rst_n) 
	        wfifo_wren <= 0;
	    else if(wfifo_wren == 1)
	        wfifo_wren <= 0;
	    else if(byte_cnt == 7 && datain_valid )  //Դݴ8Σдʹһ
	        wfifo_wren <= 1;
	    else 
	        wfifo_wren <= 0;
	 end
	     
	always @(posedge rd_clk or negedge rst_n) begin
	    if(!rst_n)
	        data <= 127'b0;
	    else 
	        data <= rfifo_dout; 
	end     
	
	//rfifo128bitݲ1616bit
	always @(posedge rd_clk or negedge rst_n) begin
	    if(!rst_n) begin
	        pic_data <= 16'b0;
	        i <=0;
	        i_d0 <= 0;
	    end
	    else if(rdata_req) begin
	        if(i == 7)begin
	            pic_data <= dataout[i_d0];
	            i <= 0;
	            i_d0 <= i;
	        end
	        else begin
	            pic_data <= dataout[i_d0];
	            i <= i + 1;
	            i_d0 <= i;
	        end
	    end 
	    else begin
	        pic_data <= pic_data;
	        i <=0;
	        i_d0 <= 0;
	    end
	end  
	
	always @(posedge clk_100 or negedge rst_n) begin
	    if(!rst_n)
	        rd_load_d0 <= 1'b0;
	    else
	        rd_load_d0 <= rd_load;      
	end 
	
	//ԴźŽλĴ
	always @(posedge clk_100 or negedge rst_n) begin
	    if(!rst_n)
	        rd_load_d <= 1'b0;
	    else
	        rd_load_d <= {rd_load_d[14:0],rd_load_d0};       
	end 
	
	//һθλƽfifoλʱ  
	always @(posedge clk_100 or negedge rst_n) begin
	    if(!rst_n)
	        rdfifo_rst_h <= 1'b0;
	    else if(rd_load_d[0] && !rd_load_d[14])
	        rdfifo_rst_h <= 1'b1;   
	    else
	        rdfifo_rst_h <= 1'b0;              
	end  
	
	//ԴźŽλĴ
	 always @(posedge wr_clk or negedge rst_n) begin
	    if(!rst_n)begin
	        wr_load_d0 <= 1'b0;
	        wr_load_d  <= 16'b0;        
	    end     
	    else begin
	        wr_load_d0 <= wr_load;
	        wr_load_d <= {wr_load_d[14:0],wr_load_d0};      
	    end                 
	end  
	
	//һθλƽfifoλʱ 
	 always @(posedge wr_clk or negedge rst_n) begin
	    if(!rst_n)
	      wfifo_rst_h <= 1'b0;          
	    else if(wr_load_d[0] && !wr_load_d[15])
	      wfifo_rst_h <= 1'b1;       
	    else
	      wfifo_rst_h <= 1'b0;                      
	end
	//---Module instantiation---
	datapass datapass3(
		.rst_n(rst_n),
		.rdfifo_rst_h(rdfifo_rst_h),
		.pass1(datapass3_pass1),
		.wfifo_rst_h(wfifo_rst_h),
		.pass2(datapass3_pass2));

	rd_fifo rd_fifo2(
		.rst_n(datapass3_pass1),
		.write_clk(clk_100),
		.read_clk(rd_clk),
		.data_in(rfifo_din),
		.write_en(rfifo_wren),
		.read_en(rfifo_rden),
		.data_out(rfifo_dout),
		.wr_data_count(rfifo_wcount));

	rd_fifo rd_fifo3(
		.rst_n(datapass3_pass2),
		.write_clk(wr_clk),
		.read_clk(clk_100),
		.data_in(wfifo_din),
		.write_en(wfifo_wren),
		.read_en(wfifo_rden),
		.data_out(wfifo_dout),
		.wr_data_count(wfifo_rcount));

endmodule    //ddr3_fifo_ctrl

