module ddr3_top(
	clk_200m,
	sys_rst_n,
	sys_init_done,
	app_addr_rd_min,
	app_addr_rd_max,
	rd_bust_len,
	app_addr_wr_min,
	app_addr_wr_max,
	wr_bust_len,
	ddr3_read_valid,
	ddr3_pingpang_en,
	wr_clk,
	rd_clk,
	datain_valid,
	datain,
	rdata_req,
	rd_load,
	wr_load,
	ddr3_addr,
	ddr3_ba,
	ddr3_ras_n,
	ddr3_cas_n,
	ddr3_we_n,
	ddr3_reset_n,
	ddr3_ck_p,
	ddr3_ck_n,
	ddr3_cke,
	ddr3_cs_n,
	ddr3_dm,
	ddr3_odt,
	dataout,
	init_calib_complete,
	ddr3_dq,
	ddr3_dqs_n,
	ddr3_dqs_p);

	//---Ports declearation: generated by Robei---
	input clk_200m;
	input sys_rst_n;
	input sys_init_done;
	input [27:0] app_addr_rd_min;
	input [27:0] app_addr_rd_max;
	input [7:0] rd_bust_len;
	input [27:0] app_addr_wr_min;
	input [27:0] app_addr_wr_max;
	input [7:0] wr_bust_len;
	input ddr3_read_valid;
	input ddr3_pingpang_en;
	input wr_clk;
	input rd_clk;
	input datain_valid;
	input [15:0] datain;
	input rdata_req;
	input rd_load;
	input wr_load;
	output [13:0] ddr3_addr;
	output [2:0] ddr3_ba;
	output ddr3_ras_n;
	output ddr3_cas_n;
	output ddr3_we_n;
	output ddr3_reset_n;
	output ddr3_ck_p;
	output ddr3_ck_n;
	output ddr3_cke;
	output ddr3_cs_n;
	output [1:0] ddr3_dm;
	output ddr3_odt;
	output [15:0] dataout;
	output init_calib_complete;
	inout [15:0] ddr3_dq;
	inout [1:0] ddr3_dqs_n;
	inout [1:0] ddr3_dqs_p;

	wire clk_200m;
	wire sys_rst_n;
	wire sys_init_done;
	wire [27:0] app_addr_rd_min;
	wire [27:0] app_addr_rd_max;
	wire [7:0] rd_bust_len;
	wire [27:0] app_addr_wr_min;
	wire [27:0] app_addr_wr_max;
	wire [7:0] wr_bust_len;
	wire ddr3_read_valid;
	wire ddr3_pingpang_en;
	wire wr_clk;
	wire rd_clk;
	wire datain_valid;
	wire [15:0] datain;
	wire rdata_req;
	wire rd_load;
	wire wr_load;
	wire [13:0] ddr3_addr;
	wire [2:0] ddr3_ba;
	wire ddr3_ras_n;
	wire ddr3_cas_n;
	wire ddr3_we_n;
	wire ddr3_reset_n;
	wire ddr3_ck_p;
	wire ddr3_ck_n;
	wire ddr3_cke;
	wire ddr3_cs_n;
	wire [1:0] ddr3_dm;
	wire ddr3_odt;
	wire [15:0] dataout;
	wire init_calib_complete;
	wire [15:0] ddr3_dq;
	wire [1:0] ddr3_dqs_n;
	wire [1:0] ddr3_dqs_p;
	wire [10:0] ddr3_fifo_ctrl3_wfifo_rcount;
	wire [10:0] ddr3_fifo_ctrl3_rfifo_wcount;
	wire ddr3_rw1_rfifo_wren;
	wire mig3_ui_clk;
	wire mig3_ui_clk_sync_rst;
	wire mig3_init_calib_complete;
	wire mig3_app_rdy;
	wire mig3_app_wdf_rdy;
	wire mig3_app_rd_data_valid;
	wire [27:0] ddr3_rw1_app_addr;
	wire ddr3_rw1_app_en;
	wire ddr3_rw1_app_wdf_end;
	wire [2:0] ddr3_rw1_app_cmd;
	wire [127:0] mig3_app_rd_data;
	wire [127:0] ddr3_fifo_ctrl3_wfifo_dout;
	wire change24_rst_n;
	wire [30:0] change24_p3;
	wire ddr3_rw1_app_wdf_wren;
	assign init_calib_complete = mig3_init_calib_complete;

	//----Code starts here: integrated by Robei-----
	
	
	
	
	//---Module instantiation---
	ddr3_rw ddr3_rw1(
		.ui_clk(mig3_ui_clk),
		.ui_clk_sync_rst(mig3_ui_clk_sync_rst),
		.init_calib_complete(mig3_init_calib_complete),
		.app_rdy(mig3_app_rdy),
		.app_wdf_rdy(mig3_app_wdf_rdy),
		.app_rd_data_valid(mig3_app_rd_data_valid),
		.wfifo_rcount(ddr3_fifo_ctrl3_wfifo_rcount),
		.rfifo_wcount(ddr3_fifo_ctrl3_rfifo_wcount),
		.rd_load(rd_load),
		.wr_load(wr_load),
		.app_addr_rd_min(app_addr_rd_min),
		.app_addr_rd_max(app_addr_rd_max),
		.rd_bust_len(rd_bust_len),
		.app_addr_wr_min(app_addr_wr_min),
		.app_addr_wr_max(app_addr_wr_max),
		.wr_bust_len(wr_bust_len),
		.ddr3_read_valid(ddr3_read_valid),
		.ddr3_pingpang_en(ddr3_pingpang_en),
		.rfifo_wren(ddr3_rw1_rfifo_wren),
		.app_addr(ddr3_rw1_app_addr),
		.app_en(ddr3_rw1_app_en),
		.app_wdf_wren(ddr3_rw1_app_wdf_wren),
		.app_wdf_end(ddr3_rw1_app_wdf_end),
		.app_cmd(ddr3_rw1_app_cmd));

	ddr3_fifo_ctrl ddr3_fifo_ctrl3(
		.rst_n(change24_rst_n),
		.wr_clk(wr_clk),
		.rd_clk(rd_clk),
		.clk_100(mig3_ui_clk),
		.datain_valid(datain_valid),
		.datain(datain),
		.rfifo_din(mig3_app_rd_data),
		.rdata_req(rdata_req),
		.rfifo_wren(ddr3_rw1_rfifo_wren),
		.wfifo_rden(ddr3_rw1_app_wdf_wren),
		.rd_load(rd_load),
		.wr_load(wr_load),
		.wfifo_dout(ddr3_fifo_ctrl3_wfifo_dout),
		.wfifo_rcount(ddr3_fifo_ctrl3_wfifo_rcount),
		.rfifo_wcount(ddr3_fifo_ctrl3_rfifo_wcount),
		.pic_data(dataout));

	mig mig3(
		.ddr3_addr(ddr3_addr),
		.ddr3_ba(ddr3_ba),
		.ddr3_cas_n(ddr3_cas_n),
		.ddr3_ck_n(ddr3_ck_n),
		.ddr3_ck_p(ddr3_ck_p),
		.ddr3_cke(ddr3_cke),
		.ddr3_ras_n(ddr3_ras_n),
		.ddr3_reset_n(ddr3_reset_n),
		.ddr3_we_n(ddr3_we_n),
		.ddr3_dq(ddr3_dq),
		.ddr3_dqs_n(ddr3_dqs_n),
		.ddr3_dqs_p(ddr3_dqs_p),
		.ddr3_cs_n(ddr3_cs_n),
		.ddr3_dm(ddr3_dm),
		.ddr3_odt(ddr3_odt),
		.app_addr(ddr3_rw1_app_addr),
		.app_cmd(ddr3_rw1_app_cmd),
		.app_en(ddr3_rw1_app_en),
		.app_wdf_data(ddr3_fifo_ctrl3_wfifo_dout),
		.app_wdf_end(ddr3_rw1_app_wdf_end),
		.app_wdf_wren(ddr3_rw1_app_wdf_wren),
		.app_rd_data(mig3_app_rd_data),
		.app_rd_data_valid(mig3_app_rd_data_valid),
		.init_calib_complete(mig3_init_calib_complete),
		.app_rdy(mig3_app_rdy),
		.app_wdf_rdy(mig3_app_wdf_rdy),
		.ui_clk(mig3_ui_clk),
		.ui_clk_sync_rst(mig3_ui_clk_sync_rst),
		.app_wdf_mask(change24_p3),
		.sys_clk_i(clk_200m),
		.clk_ref_i(clk_200m),
		.sys_rst(sys_rst_n));

	change2 change24(
		.sys_init_done(sys_init_done),
		.sys_rst_n(sys_rst_n),
		.rst_n(change24_rst_n),
		.p3(change24_p3));

endmodule    //ddr3_top

