module rd_fifo(
	rst_n,
	write_clk,
	read_clk,
	data_in,
	write_en,
	read_en,
	data_out,
	wr_data_count,
	empty,
	full);

	//---Ports declearation: generated by Robei---
	input rst_n;
	input write_clk;
	input read_clk;
	input [127:0] data_in;
	input write_en;
	input read_en;
	output [127:0] data_out;
	output [10:0] wr_data_count;
	output empty;
	output full;

	wire rst_n;
	wire write_clk;
	wire read_clk;
	wire [127:0] data_in;
	wire write_en;
	wire read_en;
	reg [127:0] data_out;
	wire [10:0] wr_data_count;
	wire empty;
	wire full;

	//----Code starts here: integrated by Robei-----
	parameter   data_width = 128;// FIFO
	parameter   data_depth = 512;// FIFO
	parameter   address_width = 9; // ַȣΪ2^nFIFOҪĶ/дָλΪ(n+1)λһλΪ۷־λ
	reg    [data_width-1:0] FIFO_RAM [data_depth-1:0];// RAM壬ڴFIFO
	 
	reg    [address_width:0]    wr_addr_p;//дַָ
	reg    [address_width:0]    rd_addr_p;//ַָ
	 
	wire   [address_width-1:0]  wr_addr;//дRAM ַ
	wire   [address_width-1:0]  rd_addr;//RAM ַ
	 
	wire   [address_width:0]    wr_addr_gray;//дַָӦĸ
	reg    [address_width:0]    wr_addr_gray_d1;
	reg    [address_width:0]    wr_addr_gray_d2;//дַָͬʱӦĸ
	 
	wire   [address_width:0]    rd_addr_gray;//ַָӦĸ
	reg    [address_width:0]    rd_addr_gray_d1;
	reg    [address_width:0]    rd_addr_gray_d2;//ַָͬдʱӦĸ
	 
	// дָ仯
	always@(posedge write_clk or negedge rst_n)begin
	    if(!rst_n)
	        wr_addr_p <='h0;
	    else if(write_en && (~full))// дʹҷ
	        wr_addr_p <= wr_addr_p + 1;
	    else 
	        wr_addr_p <= wr_addr_p;
	end
	assign wr_addr = wr_addr_p[address_width-1:0];// дRAMַڶдָĵaddress_widthλ
	// д
	always@(posedge write_clk) begin
		if(write_en && (~full))// дʹҷ
	        FIFO_RAM[wr_addr] <= data_in;
	    else
	        FIFO_RAM[wr_addr] <= FIFO_RAM[wr_addr]; 
	end
	// ָ仯      
	always@(posedge read_clk or negedge rst_n)begin
	    if(!rst_n)
	        rd_addr_p <='h0;
	    else if(read_en && (~empty))// ʹҷǿ
	        rd_addr_p <= rd_addr_p + 1;
	    else 
	        rd_addr_p <= rd_addr_p;
	end
	 
	assign rd_addr = rd_addr_p[address_width-1:0];// дRAMַڶдָĵaddress_widthλ
	 
	// 
	always@(posedge read_clk)begin
		if(read_en && (~empty))// ʹҷǿ
	        data_out <= FIFO_RAM[rd_addr];
	    else
	        data_out <='h0;
	end
	// дַָתΪ
	assign wr_addr_gray = (wr_addr_p >> 1) ^ wr_addr_p;
	assign rd_addr_gray = (rd_addr_p >> 1) ^ rd_addr_p;
	//ָͬ->дʱ
	always@(posedge write_clk)begin// 
	    rd_addr_gray_d1 <= rd_addr_gray;
	    rd_addr_gray_d2 <= rd_addr_gray_d1;
	end
	// дָ->ʱ
	always@(posedge read_clk )begin// 
	    wr_addr_gray_d1 <= wr_addr_gray;
	    wr_addr_gray_d2 <= wr_addr_gray_d1;
	end
	//־ж
	assign full = (wr_addr_gray == {~(rd_addr_gray_d2[address_width:address_width-1]),rd_addr_gray_d2[address_width-2:0]}) ;//λͬλͬ
	assign empty = (rd_addr_gray == wr_addr_gray_d2 );// дʱÿһλͬ
	
	
	
endmodule    //rd_fifo

