module lcd_rgb_top(
	sys_clk,
	sys_rst_n,
	sys_init_done,
	post_rgb,
	post_de,
	data_in,
	lcd_clk,
	lcd_hs,
	lcd_vs,
	lcd_de,
	lcd_bl,
	lcd_rst,
	lcd_pclk,
	lcd_id,
	out_vsync,
	pixel_xpos,
	pixel_ypos,
	h_disp,
	v_disp,
	pre_rgb,
	data_req,
	lcd_rgb);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input sys_init_done;
	input [15:0] post_rgb;
	input post_de;
	input [15:0] data_in;
	output lcd_clk;
	output lcd_hs;
	output lcd_vs;
	output lcd_de;
	output lcd_bl;
	output lcd_rst;
	output lcd_pclk;
	output [15:0] lcd_id;
	output out_vsync;
	output [10:0] pixel_xpos;
	output [10:0] pixel_ypos;
	output [10:0] h_disp;
	output [10:0] v_disp;
	output [15:0] pre_rgb;
	output data_req;
	inout [23:0] lcd_rgb;

	wire sys_clk;
	wire sys_rst_n;
	wire sys_init_done;
	wire [15:0] post_rgb;
	wire post_de;
	wire [15:0] data_in;
	wire lcd_clk;
	wire lcd_hs;
	wire lcd_vs;
	wire lcd_de;
	wire lcd_bl;
	wire lcd_rst;
	wire lcd_pclk;
	wire [15:0] lcd_id;
	wire out_vsync;
	wire [10:0] pixel_xpos;
	wire [10:0] pixel_ypos;
	wire [10:0] h_disp;
	wire [10:0] v_disp;
	wire [15:0] pre_rgb;
	wire data_req;
	wire [23:0] lcd_rgb;
	wire [15:0] rd_id3_lcd_id;
	wire change34_rst_out;

	//----Code starts here: integrated by Robei-----
	//wire define
	wire  [15:0] lcd_rgb_565;           //16λlcd
	wire  [15:0] colour_rgb;           //16λlcd
	wire  [23:0] lcd_rgb_o ;            //LCD ɫ
	wire  [23:0] lcd_rgb_i ;            //LCD ɫ
	
	//ͷ16bitתΪ24bitlcd
	assign lcd_rgb_o = {lcd_rgb_565[15:11],3'b000,lcd_rgb_565[10:5],2'b00,
	                    lcd_rgb_565[4:0],3'b000};          
	
	assign lcd_rgb_565 = post_de ? post_rgb   : 16'd0;
	//assign lcd_rgb_565 = post_de ? colour_rgb   : 16'd0;
	assign pre_rgb = lcd_de  ? colour_rgb : 16'd0;
	
	//ݷл
	assign lcd_rgb = post_de ?  lcd_rgb_o :  {24{1'bz}};
	assign lcd_rgb_i = lcd_rgb;
	            
	
	
	
	//---Module instantiation---
	clk_div clk_div1(
		.clk(sys_clk),
		.rst_n(sys_rst_n),
		.lcd_id(rd_id3_lcd_id),
		.lcd_pclk(lcd_clk));

	lcd_driver lcd_driver2(
		.lcd_clk(lcd_clk),
		.sys_rst_n(change34_rst_out),
		.lcd_id(rd_id3_lcd_id),
		.pixel_data(data_in),
		.data_req(data_req),
		.pixel_xpos(pixel_xpos),
		.pixel_ypos(pixel_ypos),
		.h_disp(h_disp),
		.v_disp(v_disp),
		.out_vsync(out_vsync),
		.lcd_hs(lcd_hs),
		.lcd_vs(lcd_vs),
		.lcd_de(lcd_de),
		.lcd_rgb(colour_rgb),
		.lcd_bl(lcd_bl),
		.lcd_rst(lcd_rst),
		.lcd_pclk(lcd_pclk));

	rd_id rd_id3(
		.clk(sys_clk),
		.rst_n(sys_rst_n),
		.lcd_rgb(lcd_rgb_i),
		.lcd_id(rd_id3_lcd_id));

	change3 change34(
		.sys_rst_n(sys_rst_n),
		.sys_init_done(sys_init_done),
		.rst_out(change34_rst_out));

endmodule    //lcd_rgb_top

