module ov5640_dri(
	clk,
	rst_n,
	cam_pclk,
	cam_vsync,
	cam_href,
	cam_data,
	cmos_h_pixel,
	total_h_pixel,
	total_v_pixel,
	cam_rst_n,
	cam_pwdn,
	cam_scl,
	cam_init_done,
	cmos_frame_vsync,
	cmos_frame_href,
	cmos_frame_valid,
	cmos_frame_data,
	cam_sda,
	capture_start,
	cmos_v_pixel);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	input cam_pclk;
	input cam_vsync;
	input cam_href;
	input [7:0] cam_data;
	input [12:0] cmos_h_pixel;
	input [12:0] total_h_pixel;
	input [12:0] total_v_pixel;
	output cam_rst_n;
	output cam_pwdn;
	output cam_scl;
	output cam_init_done;
	output cmos_frame_vsync;
	output cmos_frame_href;
	output cmos_frame_valid;
	output [15:0] cmos_frame_data;
	inout cam_sda;
	input capture_start;
	input [12:0] cmos_v_pixel;

	wire clk;
	wire rst_n;
	wire cam_pclk;
	wire cam_vsync;
	wire cam_href;
	wire [7:0] cam_data;
	wire [12:0] cmos_h_pixel;
	wire [12:0] total_h_pixel;
	wire [12:0] total_v_pixel;
	wire cam_rst_n;
	wire cam_pwdn;
	wire cam_scl;
	wire cam_init_done;
	wire cmos_frame_vsync;
	wire cmos_frame_href;
	wire cmos_frame_valid;
	wire [15:0] cmos_frame_data;
	wire cam_sda;
	wire capture_start;
	wire [12:0] cmos_v_pixel;
	wire i2c_ov5640_rgb565_cfg2_i2c_rh_wl;
	wire i2c_dri1_i2c_done;
	wire [7:0] i2c_dri1_i2c_data_r;
	wire i2c_ov5640_rgb565_cfg2_i2c_exec;
	wire i2c_dri1_dri_clk;
	wire [23:0] i2c_ov5640_rgb565_cfg2_i2c_data;
	wire [15:0] change4_out16_i2c_data;
	wire [7:0] change4_out8_i2c_data;
	wire change4_bit_ctrl;
	wire change4_rst;

	//----Code starts here: integrated by Robei-----
	
	
	//Դģʽѡ 0ģʽ 1Դģʽ
	assign  cam_pwdn  = 1'b0;
	assign  cam_rst_n = 1'b1;
	
	//---Module instantiation---
	i2c_dri #( 7'b1010000, 26'd50_000_000, 18'd250_000, 8'b0000_0001, 8'b0000_0010, 8'b0000_0100, 8'b0000_1000, 8'b0001_0000, 8'b0010_0000, 8'b0100_0000, 8'b1000_0000) i2c_dri1(
		.clk(clk),
		.rst_n(rst_n),
		.i2c_exec(i2c_ov5640_rgb565_cfg2_i2c_exec),
		.bit_ctrl(change4_bit_ctrl),
		.i2c_rh_wl(i2c_ov5640_rgb565_cfg2_i2c_rh_wl),
		.i2c_addr(change4_out16_i2c_data),
		.i2c_data_w(change4_out8_i2c_data),
		.i2c_data_r(i2c_dri1_i2c_data_r),
		.i2c_done(i2c_dri1_i2c_done),
		.scl(cam_scl),
		.dri_clk(i2c_dri1_dri_clk),
		.sda(cam_sda));

	i2c_ov5640_rgb565_cfg #( 8'd250  ) i2c_ov5640_rgb565_cfg2(
		.clk(i2c_dri1_dri_clk),
		.rst_n(rst_n),
		.i2c_data_r(i2c_dri1_i2c_data_r),
		.i2c_done(i2c_dri1_i2c_done),
		.cmos_h_pixel(cmos_h_pixel),
		.cmos_v_pixel(cmos_v_pixel),
		.total_h_pixel(total_h_pixel),
		.total_v_pixel(total_v_pixel),
		.i2c_exec(i2c_ov5640_rgb565_cfg2_i2c_exec),
		.i2c_data(i2c_ov5640_rgb565_cfg2_i2c_data),
		.i2c_rh_wl(i2c_ov5640_rgb565_cfg2_i2c_rh_wl),
		.init_done(cam_init_done));

	cmos_capture_data #( 4'd10) cmos_capture_data3(
		.rst_n(change4_rst),
		.cam_pclk(cam_pclk),
		.cam_vsync(cam_vsync),
		.cam_href(cam_href),
		.cam_data(cam_data),
		.cmos_frame_vsync(cmos_frame_vsync),
		.cmos_frame_href(cmos_frame_href),
		.cmos_frame_valid(cmos_frame_valid),
		.cmos_frame_data(cmos_frame_data));

	change change4(
		.in_i2c_data(i2c_ov5640_rgb565_cfg2_i2c_data),
		.out8_i2c_data(change4_out8_i2c_data),
		.out16_i2c_data(change4_out16_i2c_data),
		.bit_ctrl(change4_bit_ctrl),
		.rst_n(rst_n),
		.capture_start(capture_start),
		.rst(change4_rst));

endmodule    //ov5640_dri

