module picture_size(
	rst_n,
	clk,
	ID_lcd,
	cmos_h_pixel,
	cmos_v_pixel,
	total_h_pixel,
	total_v_pixel,
	sdram_max_addr);

	//----Parameters:: generated by Robei-----
	parameter ID_4342 =   16'h4342;
	parameter ID_7084 =   16'h7084;
	parameter ID_7016 =   16'h7016;
	parameter ID_1018 =   16'h1018;

	//---Ports declearation: generated by Robei---
	input rst_n;
	input clk;
	input [15:0] ID_lcd;
	output [12:0] cmos_h_pixel;
	output [12:0] cmos_v_pixel;
	output [12:0] total_h_pixel;
	output [12:0] total_v_pixel;
	output [27:0] sdram_max_addr;

	wire rst_n;
	wire clk;
	wire [15:0] ID_lcd;
	reg [12:0] cmos_h_pixel;
	reg [12:0] cmos_v_pixel;
	reg [12:0] total_h_pixel;
	reg [12:0] total_v_pixel;
	reg [27:0] sdram_max_addr;

	//----Code starts here: integrated by Robei-----
	always @(posedge clk or negedge rst_n) begin 
	    if(!rst_n) begin
	        cmos_h_pixel <= 13'b0;
	        cmos_v_pixel <= 13'd0;
	        sdram_max_addr <= 23'd0;        
	    end 
	    else begin    
	        case(ID_lcd ) 
	            16'h4342 : begin
	                cmos_h_pixel   = 13'd480;    
	                cmos_v_pixel   = 13'd272;
	                sdram_max_addr = 23'd130560;
	            end 
	            16'h7084 : begin
	                cmos_h_pixel   = 13'd800;    
	                cmos_v_pixel   = 13'd480;           
	                sdram_max_addr = 23'd384000;
	            end 
	            16'h7016 : begin
	                cmos_h_pixel   = 13'd1024;    
	                cmos_v_pixel   = 13'd600;           
	                sdram_max_addr = 23'd614400;
	            end    
	            16'h1018 : begin
	                cmos_h_pixel   = 13'd1280;    
	                cmos_v_pixel   = 13'd800;           
	                sdram_max_addr = 23'd1024000;
	            end 
	        default : begin
	                cmos_h_pixel   = 13'd800;    
	                cmos_v_pixel   = 13'd480;           
	                sdram_max_addr = 23'd384000;
	        end
	        endcase
	    end    
	end 
	
	//HTSVTSûӰͷͼ֡
	always @(*) begin
	    case(ID_lcd)
	        ID_4342 : begin 
	            total_h_pixel = 13'd1800;
	            total_v_pixel = 13'd1000;
	        end 
	        ID_7084 : begin  
	            total_h_pixel = 13'd1800;
	            total_v_pixel = 13'd1000;
	        end 
	        ID_7016 : begin  
	            total_h_pixel = 13'd2200;
	            total_v_pixel = 13'd1000;
	        end 
	        ID_1018 : begin 
	            total_h_pixel = 13'd2570;
	            total_v_pixel = 13'd980;
	        end 
	    default : begin
	            total_h_pixel = 13'd1800;
	            total_v_pixel = 13'd1000;
	    end 
	    endcase
	end 
endmodule    //picture_size

