module top_digital_recognition(
	sys_clk,
	sys_rst_n,
	cam_pclk,
	cam_vsync,
	cam_href,
	cam_data,
	cam_rst_n,
	cam_pwdn,
	cam_scl,
	ddr3_addr,
	ddr3_ba,
	ddr3_ras_n,
	ddr3_cas_n,
	ddr3_we_n,
	ddr3_reset_n,
	ddr3_ck_p,
	ddr3_ck_n,
	ddr3_cke,
	ddr3_cs_n,
	ddr3_dm,
	ddr3_odt,
	lcd_hs,
	lcd_vs,
	lcd_de,
	lcd_bl,
	lcd_rst,
	lcd_pclk,
	digital_out,
	seg_sel,
	seg_led,
	cam_sda,
	ddr3_dq,
	ddr3_dqs_n,
	ddr3_dqs_p,
	lcd_rgb);

	//---Ports declearation: generated by Robei---
	input sys_clk;
	input sys_rst_n;
	input cam_pclk;
	input cam_vsync;
	input cam_href;
	input [7:0] cam_data;
	output cam_rst_n;
	output cam_pwdn;
	output cam_scl;
	output [13:0] ddr3_addr;
	output [2:0] ddr3_ba;
	output ddr3_ras_n;
	output ddr3_cas_n;
	output ddr3_we_n;
	output ddr3_reset_n;
	output ddr3_ck_p;
	output ddr3_ck_n;
	output ddr3_cke;
	output ddr3_cs_n;
	output [1:0] ddr3_dm;
	output ddr3_odt;
	output lcd_hs;
	output lcd_vs;
	output lcd_de;
	output lcd_bl;
	output lcd_rst;
	output lcd_pclk;
	output [3:0] digital_out;
	output [5:0] seg_sel;
	output [7:0] seg_led;
	inout cam_sda;
	inout [15:0] ddr3_dq;
	inout [1:0] ddr3_dqs_n;
	inout [1:0] ddr3_dqs_p;
	inout [23:0] lcd_rgb;

	wire sys_clk;
	wire sys_rst_n;
	wire cam_pclk;
	wire cam_vsync;
	wire cam_href;
	wire [7:0] cam_data;
	wire cam_rst_n;
	wire cam_pwdn;
	wire cam_scl;
	wire [13:0] ddr3_addr;
	wire [2:0] ddr3_ba;
	wire ddr3_ras_n;
	wire ddr3_cas_n;
	wire ddr3_we_n;
	wire ddr3_reset_n;
	wire ddr3_ck_p;
	wire ddr3_ck_n;
	wire ddr3_cke;
	wire ddr3_cs_n;
	wire [1:0] ddr3_dm;
	wire ddr3_odt;
	wire lcd_hs;
	wire lcd_vs;
	wire lcd_de;
	wire lcd_bl;
	wire lcd_rst;
	wire lcd_pclk;
	wire [3:0] digital_out;
	wire [5:0] seg_sel;
	wire [7:0] seg_led;
	wire cam_sda;
	wire [15:0] ddr3_dq;
	wire [1:0] ddr3_dqs_n;
	wire [1:0] ddr3_dqs_p;
	wire [23:0] lcd_rgb;
	wire clk_ip6_clk_50m;
	wire [15:0] lcd_rgb_top3_lcd_id;
	wire [12:0] picture_size1_cmos_h_pixel;
	wire [12:0] picture_size1_cmos_v_pixel;
	wire [12:0] picture_size1_total_h_pixel;
	wire [12:0] picture_size1_total_v_pixel;
	wire [27:0] picture_size1_sdram_max_addr;
	wire ov5640_dri4_cmos_frame_vsync;
	wire ov5640_dri4_cmos_frame_valid;
	wire [15:0] ov5640_dri4_cmos_frame_data;
	wire clk_ip6_clk_200m;
	wire [15:0] digital_top4_post_rgb;
	wire digital_top4_post_frame_de;
	wire lcd_rgb_top3_lcd_hs;
	wire lcd_rgb_top3_lcd_vs;
	wire lcd_rgb_top3_lcd_de;
	wire [10:0] lcd_rgb_top3_pixel_xpos;
	wire [10:0] lcd_rgb_top3_pixel_ypos;
	wire [15:0] lcd_rgb_top3_pre_rgb;
	wire lcd_rgb_top3_data_req;
	wire [15:0] ddr3_top5_dataout;
	wire lcd_rgb_top3_lcd_clk;
	wire lcd_rgb_top3_out_vsync;
	wire [7:0] change57_rd_bust_len;
	wire [23:0] digital_top4_digit;
	wire change57_reset;
	assign lcd_de = digital_top4_post_frame_de;

	//----Code starts here: integrated by Robei-----
	//wire define                          
	wire         clk_50m                   ;  //50mhzʱ,ṩlcdʱ
	wire         locked                    ;  //ʱź
	wire         rst_n                     ;  //ȫָλ 								    
	wire         i2c_exec                  ;  //I2Cִź
	wire  [23:0] i2c_data                  ;  //I2CҪõĵַ(8λַ,8λ)          
	wire         cam_init_done             ;  //ͷʼ
	wire         i2c_done                  ;  //I2CĴź
	wire         i2c_dri_clk               ;  //I2Cʱ								    
	wire         wr_en                     ;  //DDR3ģдʹ
	wire  [15:0] wr_data                   ;  //DDR3ģд
	wire         rdata_req                 ;  //DDR3ģʹ
	wire  [15:0] rd_data                   ;  //DDR3ģ
	wire         cmos_frame_valid          ;  //Чʹź
	wire         init_calib_complete       ;  //DDR3ʼinit_calib_complete
	wire         sys_init_done             ;  //ϵͳʼ(DDRʼ+ͷʼ)
	wire         clk_200m                  ;  //ddr3οʱ
	wire         cmos_frame_vsync          ;  //֡Чͬź
	
	wire         cmos_frame_href           ;  //֡Чͬź 
	wire  [27:0] app_addr_rd_min           ;  //DDR3ʼַ
	wire  [27:0] app_addr_rd_max           ;  //DDR3Ľַ
	wire  [7:0]  rd_bust_len               ;  //DDR3жʱͻ
	wire  [27:0] app_addr_wr_min           ;  //дDDR3ʼַ
	wire  [27:0] app_addr_wr_max           ;  //дDDR3Ľַ
	wire  [7:0]  wr_bust_len               ;  //DDR3дʱͻ 
	wire         lcd_clk                   ;  //ƵLCD ʱ
	wire  [12:0] h_disp                    ;  //LCDˮƽֱ
	wire  [12:0] v_disp                    ;  //LCDֱֱ     
	wire  [10:0] h_pixel                   ;  //ddr3ˮƽֱ        
	wire  [10:0] v_pixel                   ;  //ddr3ֱֱ 
	wire  [15:0] lcd_id                    ;  //LCDID
	wire  [27:0] ddr3_addr_max             ;  //DDR3дַ 
	wire         i2c_rh_wl                 ;  //I2Cдź             
	wire  [7:0]  i2c_data_r                ;  //I2C 
	wire  [12:0] total_h_pixel             ;  //ˮƽشС 
	wire  [12:0] total_v_pixel             ;  //ֱشС
	wire  [15:0] post_rgb                  ;  //ͼ
	wire         post_frame_vsync          ;  //ĳź
	wire         post_frame_de             ;  //Чʹ 
	wire  [10:0] pixel_xpos                ;  //ص
	wire  [10:0] pixel_ypos                ;  //ص  
	wire  [23:0] digit                     ;  //ص 
	wire   [15:0]         color_rgb       ;
	
	wire                  hs_t            ;
	wire                  vs_t            ;
	wire                  de_t            ;    
	 assign digital_out=digit;
	
	assign  rst_n = sys_rst_n & locked;
	assign  sys_init_done = init_calib_complete;
	//---Module instantiation---
	picture_size #(   16'h4342,   16'h7084,   16'h7016,   16'h1018) picture_size1(
		.rst_n(rst_n),
		.clk(clk_ip6_clk_50m),
		.ID_lcd(lcd_rgb_top3_lcd_id),
		.cmos_h_pixel(picture_size1_cmos_h_pixel),
		.cmos_v_pixel(picture_size1_cmos_v_pixel),
		.total_h_pixel(picture_size1_total_h_pixel),
		.total_v_pixel(picture_size1_total_v_pixel),
		.sdram_max_addr(picture_size1_sdram_max_addr));

	lcd_rgb_top lcd_rgb_top3(
		.sys_clk(clk_ip6_clk_50m),
		.sys_rst_n(rst_n),
		.sys_init_done(sys_init_done),
		.post_rgb(digital_top4_post_rgb),
		.post_de(digital_top4_post_frame_de),
		.data_in(ddr3_top5_dataout),
		.lcd_clk(lcd_rgb_top3_lcd_clk),
		.lcd_hs(lcd_rgb_top3_lcd_hs),
		.lcd_vs(lcd_rgb_top3_lcd_vs),
		.lcd_de(lcd_rgb_top3_lcd_de),
		.lcd_bl(lcd_bl),
		.lcd_rst(lcd_rst),
		.lcd_pclk(lcd_pclk),
		.lcd_id(lcd_rgb_top3_lcd_id),
		.out_vsync(lcd_rgb_top3_out_vsync),
		.pixel_xpos(lcd_rgb_top3_pixel_xpos),
		.pixel_ypos(lcd_rgb_top3_pixel_ypos),
		.pre_rgb(lcd_rgb_top3_pre_rgb),
		.data_req(lcd_rgb_top3_data_req),
		.lcd_rgb(lcd_rgb));

	digital_top #( 1  , 4  , 11 ) digital_top4(
		.clk(lcd_rgb_top3_lcd_clk),
		.rst_n(rst_n),
		.pre_frame_vsync(lcd_rgb_top3_lcd_vs),
		.pre_frame_hsync(lcd_rgb_top3_lcd_hs),
		.pre_frame_de(lcd_rgb_top3_lcd_de),
		.pre_rgb(lcd_rgb_top3_pre_rgb),
		.xpos(lcd_rgb_top3_pixel_xpos),
		.ypos(lcd_rgb_top3_pixel_ypos),
		.post_frame_vsync(lcd_vs),
		.post_frame_hsync(lcd_hs),
		.post_frame_de(digital_top4_post_frame_de),
		.post_rgb(digital_top4_post_rgb),
		.digit(digital_top4_digit));

	ov5640_dri ov5640_dri4(
		.clk(clk_ip6_clk_50m),
		.rst_n(rst_n),
		.cam_pclk(cam_pclk),
		.cam_vsync(cam_vsync),
		.cam_href(cam_href),
		.cam_data(cam_data),
		.cmos_h_pixel(picture_size1_cmos_h_pixel),
		.total_h_pixel(picture_size1_total_h_pixel),
		.total_v_pixel(picture_size1_total_v_pixel),
		.cam_rst_n(cam_rst_n),
		.cam_pwdn(cam_pwdn),
		.cam_scl(cam_scl),
		.cmos_frame_vsync(ov5640_dri4_cmos_frame_vsync),
		.cmos_frame_valid(ov5640_dri4_cmos_frame_valid),
		.cmos_frame_data(ov5640_dri4_cmos_frame_data),
		.cam_sda(cam_sda),
		.capture_start(init_calib_complete),
		.cmos_v_pixel(picture_size1_cmos_v_pixel));

	ddr3_top ddr3_top5(
		.clk_200m(clk_ip6_clk_200m),
		.sys_rst_n(rst_n),
		.sys_init_done(init_calib_complete),
		.app_addr_rd_max(picture_size1_sdram_max_addr),
		.rd_bust_len(change57_rd_bust_len),
		.app_addr_wr_max(picture_size1_sdram_max_addr),
		.wr_bust_len(change57_rd_bust_len),
		.wr_clk(cam_pclk),
		.rd_clk(lcd_rgb_top3_lcd_clk),
		.datain_valid(ov5640_dri4_cmos_frame_valid),
		.datain(ov5640_dri4_cmos_frame_data),
		.rdata_req(lcd_rgb_top3_data_req),
		.rd_load(lcd_rgb_top3_out_vsync),
		.wr_load(ov5640_dri4_cmos_frame_vsync),
		.ddr3_addr(ddr3_addr),
		.ddr3_ba(ddr3_ba),
		.ddr3_ras_n(ddr3_ras_n),
		.ddr3_cas_n(ddr3_cas_n),
		.ddr3_we_n(ddr3_we_n),
		.ddr3_reset_n(ddr3_reset_n),
		.ddr3_ck_p(ddr3_ck_p),
		.ddr3_ck_n(ddr3_ck_n),
		.ddr3_cke(ddr3_cke),
		.ddr3_cs_n(ddr3_cs_n),
		.ddr3_dm(ddr3_dm),
		.ddr3_odt(ddr3_odt),
		.dataout(ddr3_top5_dataout),
		.init_calib_complete(init_calib_complete),
		.ddr3_dq(ddr3_dq),
		.ddr3_dqs_n(ddr3_dqs_n),
		.ddr3_dqs_p(ddr3_dqs_p));

	clk_ip clk_ip6(
		.reset(change57_reset),
		.locked(locked),
		.clk_in1(sys_clk),
		.clk_200m(clk_ip6_clk_200m),
		.clk_50m(clk_ip6_clk_50m));

	change5 change57(
		.h_disp(picture_size1_cmos_h_pixel),
		.rd_bust_len(change57_rd_bust_len),
		.digit(digital_top4_digit),
		.digital_out(digital_out),
		.reset(change57_reset));

endmodule    //top_digital_recognition

